/*> Ver: V1.2 ************************************************************\

**> History :

V1.0            02/28/2001	Released
V1.1            05/06/2001	Improved UI
V1.2            04/22/2003	Upgraded to BCB 6.0 and some nice improvements
                                made by Asger Joergensen. Thanks Asger!

**> Legal issues :

              Copyright (C) 2001-2003 by Boian Mitov
              <mitov@mitov.com>
              <http://www.mitov.com>
              <http://www.openwire.org>

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. This notice may not be removed or altered from any source
                 distribution.

\***************************************************************************/
//---------------------------------------------------------------------------

#ifndef bufferlistformH
#define bufferlistformH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TBufferListFrmValues
{
public:
   TRect BoundsRect;
   int ColumnSizes[10];
   __fastcall TBufferListFrmValues()
   {
      memset(&BoundsRect, 0, sizeof(TRect));
      memset(ColumnSizes, 0, 10*sizeof(int));
   }
};
//---------------------------------------------------------------------------
class TBufferListFrm : public TForm
{
__published:	// IDE-managed Components
    TImageList *PointsImageList;
    TImageList *SmallImages;
    TImageList *ResultImageList;
   TPanel *PnlListView;
   TListView *ListView;
   TPanel *PnlButtons;
   TBitBtn *OKButton;
   TBitBtn *CancelButton;
    void __fastcall BufferListBoxDblClick(TObject *Sender);
    void __fastcall ListViewColumnClick(TObject *Sender,
          TListColumn *Column);
    void __fastcall ListViewCompare(TObject *Sender, TListItem *Item1,
          TListItem *Item2, int Data, int &Compare);
    void __fastcall FormShow(TObject *Sender);
   void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
    int  ColumnToSort;
    bool Direction;
    TBufferListFrmValues Values;
  
public:		// User declarations
    __fastcall TBufferListFrm(TComponent* Owner);

public:		// User declarations
    void __fastcall AddBuffer( AnsiString BufferName );
    int  __fastcall GetSelectedIndex();
    void __fastcall Clear();

    String ProgramDir;
};
//---------------------------------------------------------------------------
#endif
